<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="编码" prop="materialNo">
        <el-input
          v-model="queryParams.materialNo"
          placeholder="请输入编码"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="名称" prop="materialName">
        <el-input
          v-model="queryParams.materialName"
          placeholder="请输入名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="状态" prop="materialState">
        <el-select v-model="queryParams.materialState" placeholder="材料状态" clearable>
          <el-option
            v-for="dict in dict.type.yl_material_state"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['clMaterial:clMaterial:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['clMaterial:clMaterial:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['clMaterial:clMaterial:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['clMaterial:clMaterial:export']"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-refresh-right"
          size="mini"
          @click="handleSynchronize"
          v-hasPermi="['clMaterial:clMaterial:synchronizeQuotationData']"
        >同步更新报价</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="clMaterialList" :row-class-name="rowClMaterialIndex" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="序号" align="center" prop="index" width="80"/>
      <el-table-column label="id" align="center" prop="materialId" v-if="false"/>
      <el-table-column label="编码" align="center" prop="materialNo" />
      <el-table-column label="名称" align="center" prop="materialName" />
      <el-table-column label="单价" align="center" prop="materialPrice" />
      <el-table-column prop="materialState" label="状态" width="80">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.yl_material_state" :value="scope.row.materialState"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" width="250" align="center">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['clMaterial:clMaterial:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['clMaterial:clMaterial:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改材料管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="编码" prop="materialNo">
          <el-input v-model="form.materialNo" placeholder="请输入编码" :disabled="isDis"/>
        </el-form-item>
        <el-form-item label="名称" prop="materialName">
          <el-input v-model="form.materialName" placeholder="请输入名称"/>
        </el-form-item>
        <el-form-item label="单价" prop="materialPrice">
          <el-input v-model="form.materialPrice" placeholder="请输入单价" />
        </el-form-item>
        <el-form-item prop="materialState" label="停用状态" label-width="100px">
          <el-radio-group v-model="form.materialState">
            <el-radio
              v-for="dict in dict.type.yl_material_state"
              :key="dict.value"
              :label="dict.value"
            >{{dict.label}}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listClMaterial, getClMaterial, delClMaterial, addClMaterial, updateClMaterial, synchronizeUpdate } from "@/api/clMaterial/clMaterial";

export default {
  name: "ClMaterial",
  dicts: ['yl_material_state'],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 材料管理表格数据
      clMaterialList: [],
      // 弹出层标题
      title: "",
      // 是否可编辑
      isDis: false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        materialNo: null,
        materialName: null,
        materialState: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        materialNo: [
          { required: true, message: "编码不能为空", trigger: "blur" }
        ],
        materialName: [
          { required: true, message: "名称不能为空", trigger: "blur" }
        ],
        materialPrice: [
          { required: true, message: "单价不能为空", trigger: "blur" },
          {
            pattern: /^(([1-9]{1}\d{0,9})|(0{1}))(\.\d{1,2})?$/,
            message: "金额格式错误",
            trigger: "blur"
          }
        ]
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询材料管理列表 */
    getList() {
      this.loading = true;
      listClMaterial(this.queryParams).then(response => {
        this.clMaterialList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        materialId: null,
        materialNo: null,
        materialName: null,
        materialPrice: null,
        materialState: '0'
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.materialId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加材料管理";
      this.isDis = false;
      this.materialState = '0'
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const materialId = row.materialId || this.ids
      getClMaterial(materialId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改材料管理";
        this.isDis = true;
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.materialId != null) {
            updateClMaterial(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addClMaterial(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const materialIds = row.materialId || this.ids;
      this.$modal.confirm('是否确认删除材料管理编号为"' + materialIds + '"的数据项？').then(function() {
        return delClMaterial(materialIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('clMaterial/clMaterial/export', {
        ...this.queryParams
      }, `clMaterial_${new Date().getTime()}.xlsx`)
    },
    /** 序号 */
    rowClMaterialIndex({ row, rowIndex }) {
      row.index = rowIndex + 1;
    },

    /*同步更新报价实时价格*/
    handleSynchronize(){
      this.$modal.confirm('是否确认同步更新？').then(function() {
        return synchronizeUpdate();
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("更新成功");
      }).catch(() => {});
    }
  }
};
</script>
